;----------------------------------------------------------------------------------------------------------
Graphics3D 1440,900,32,1
AppTitle "FPS"
SetBuffer BackBuffer()
HidePointer
SetFont LoadFont("Tahoma",14)

Global camera
Global level
Global player
Global campitch#,camyaw#,mvx#,mvy#,mvz#
Global fpsindex#,fpstime#,fpsfold_millisecs#,fpsfps#

Const TypeLevel=1,TypePlayer=2

Global movement_counter = -250
Global movement_counter_direction = -1

Type gun
	Field model, timesincelastshot
	Field texture
End Type

Function create_player()
	player=CreateSphere()
	EntityRadius player,4.5,6
	RotateEntity player,0,180,0
	camera=CreateCamera(player)
	CameraClsMode camera,False,True

	MoveEntity camera,0,1.2,0
	PositionEntity player,0,8,0
	EntityType player,TypePlayer
End Function

;----------------------------------------------------------------------------------------------------------
Function update_player()

	mxspd#=MouseXSpeed()*0.25
	myspd#=MouseYSpeed()*0.25
		
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

	campitch=campitch+myspd
	If campitch<-85 Then campitch=-85
	If campitch>85 Then campitch=85
	RotateEntity player,campitch,EntityYaw(player)-mxspd,0
	
	If KeyDown(30) Then mvx=mvx-.1
	If KeyDown(32) Then mvx=mvx+.1
	If KeyDown(17) Then mvz=mvz+.1
	If KeyDown(31) Then mvz=mvz-.1
		
			If KeyDown(17) Or KeyDown(31) Or KeyDown(30) Or KeyDown(32)
			movement_counter = movement_counter + movement_counter_direction
			If movement_counter < -250
				movement_counter = -250
				movement_counter_direction = 6
			ElseIf movement_counter > -110
				movement_counter = -110
				movement_counter_direction = -6
			EndIf
		EndIf
	
		
	mvx=mvx/1.2
	mvz=mvz/1.2
	
	MoveEntity player,mvx,0,mvz

End Function
;----------------------------------------------------------------------------------------------------------

Function load_weapon()
	g.gun = New gun
	g\model=LoadMesh("gun.3ds",camera)
	ScaleEntity g\model, 0.25, 0.25, 0.25
	g\texture=LoadTexture("gun.jpg") 
	EntityTexture g\model,g\texture,0,0

End Function

Function update_weapon()
	For g.gun = Each gun
		xoffset# = Sin(movement_counter)*0.2
		yoffset# = Cos(movement_counter)*0.15
		zoffset# = Cos(EntityPitch(camera))+Sin(movement_counter)*0.1
		RotateEntity g\model, -90, 180, 0
		PositionEntity g\model,1.7+xoffset#,-1.8+yoffset#,1.3+zoffset#
	Next
End Function

;----------------------------------------------------------------------------------------------------------
Function load_level()
	level = LoadMesh("test.b3d")
	ScaleEntity level, 10, 10, 10
	light=CreateLight()
	EntityType level,TypeLevel
End Function
;----------------------------------------------------------------------------------------------------------


Collisions TypePlayer,TypeLevel,2,2


;----------------------------------------------------------------------------------------------------------
	create_player()
	load_weapon()
	load_level()
;----------------------------------------------------------------------------------------------------------

;MAINLOOP
While Not KeyHit(1)

;--------------------------------------------------------- 

;---------------------------------------------------------

	If KeyHit(16)
		wire=1-wire
		WireFrame wire
	EndIf

	update_player()
	update_weapon()
	
	UpdateWorld
	RenderWorld
	
	If KeyHit(63) = 1;F5
		For w = 1 To 100
			name$ = "screenshot_" + w + ".bmp"
			If FileType(name$) = 0
				If done = 0
					SaveBuffer(FrontBuffer(), name$)
					done = 1
				EndIf
			EndIf
		Next
	EndIf
	done = 0
	
	Text 10,10, "FPS = " + show_fps()
	
	Text 10,35, "Position of player: "
	Text 20,50, "X = " + EntityX(player)
	Text 20,65, "Y = " + EntityY(player)
	Text 20,80, "Z = " + EntityZ(player)
	
	Text 10,105, "Poligons = "+TrisRendered()
	
	Flip

Wend
End


;----------------------------------------------------------------------------------------------------------
Function show_fps()
	fpsindex=fpsindex+1
	fpstime=fpstime+MilliSecs()-fpsfold_millisecs
	If fpstime=>1000
		fpsfps=fpsindex
		fpstime=0
		fpsindex=0
	EndIf
	fpsfold_millisecs=MilliSecs()
	Return fpsfps
End Function
;----------------------------------------------------------------------------------------------------------